import { useCssVars as mt, ref as d, computed as x, watch as yt, onMounted as Ve, onBeforeUnmount as We, createElementBlock as i, openBlock as r, unref as b, normalizeStyle as E, normalizeClass as z, createBlock as U, createCommentVNode as v, renderSlot as $, createElementVNode as B, createSlots as qe, withCtx as P, normalizeProps as le, guardReactiveProps as se, withModifiers as He, createVNode as de, Fragment as F, renderList as Y, mergeProps as kt, toDisplayString as R, createTextVNode as $t, nextTick as wt } from "vue";
import { u as Ct, c as ve, t as Mt, p as re, a as xt, o as _t, e as Qe, g as It, b as At, d as Pt, X as Tt, G as St, f as he, q as Ot, r as Bt, i as Lt } from "./index-DISniBjo.js";
import { u as Nt } from "./useUserOptionState-BIvW1Kz7.js";
import { u as Ze } from "./useNestedProp-Cg1rd0rj.js";
import { u as Et } from "./useChartAccessibility-BWojgys7.js";
import { _ as zt } from "./Title-BjMd4WGZ.js";
import { _ as Ft } from "./PackageVersion-DV3lyC6_.js";
import { _ as Xt } from "./PenAndPaper-mmgChIlY.js";
import Rt from "./BaseIcon-C8PYAGSm.js";
import { u as jt, U as Dt } from "./usePrinter-Cw5Mv9xt.js";
import { L as Ut } from "./Legend-DPhZp44K.js";
import { _ as Yt } from "./Shape-CqqGhNJ7.js";
import { D as Gt } from "./DataTable-bu8svd8_.js";
import Vt from "./vue-ui-accordion-CFpwBwSP.js";
import Wt from "./vue-ui-skeleton-DCo7JrxG.js";
import { t as qt, u as Ht } from "./useResponsive-JZ9xq-JV.js";
import { _ as Qt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Zt = ["id"], Jt = ["xmlns", "viewBox"], Kt = ["width", "height"], ea = { key: 1 }, ta = ["id", "d"], aa = { key: 2 }, oa = ["transform"], la = ["d", "fill", "stroke", "stroke-width", "onMouseenter", "onClick"], sa = ["d", "fill", "stroke", "stroke-width"], ra = ["d", "fill"], na = ["d", "fill", "stroke", "stroke-width", "onMouseenter", "onClick"], ua = ["d", "fill", "stroke", "stroke-width"], ia = ["d", "fill", "stroke", "stroke-width"], ca = ["d", "fill", "stroke", "stroke-width"], da = { key: 0 }, va = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], ha = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], fa = ["cx", "cy", "r", "stroke", "stroke-width", "fill"], ga = ["transform", "fill", "text-anchor", "font-size", "font-weight"], pa = { key: 1 }, ba = ["font-size", "font-weight", "fill"], ma = ["href"], ya = ["transform", "text-anchor", "font-size", "font-weight", "fill"], ka = {
  key: 5,
  class: "vue-data-ui-watermark"
}, $a = ["onClick"], wa = {
  key: 8,
  "data-dom-to-png-ignore": "",
  class: "reset-wrapper"
}, Ca = { style: { "text-align": "right", width: "100%" } }, Ma = {
  __name: "vue-ui-chord",
  props: {
    dataset: {
      type: Object,
      default() {
        return {};
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend", "selectGroup", "selectRibbon"],
  setup(Je, { expose: Ke, emit: et }) {
    mt((t) => ({
      "7189608a": t.slicerColor
    }));
    const { vue_ui_chord: tt } = Ct(), f = Je, Z = et, L = d(!!f.dataset && Object.hasOwn(f.dataset, "matrix")), T = d(ve()), w = d(null), m = d(null), g = d(null), fe = d(0), G = d(null), ge = d(null), pe = d(null), be = d(null), me = d(null), ye = d(0), ke = d(0), $e = d(0), V = d(!1), ne = d(null), a = x({
      get: () => Ae(),
      set: (t) => t
    }), { userOptionsVisible: ue, setUserOptionsVisibility: we, keepUserOptionState: Ce } = Nt({ config: a.value }), { svgRef: W } = Et({ config: a.value.style.chart.title }), { isPrinting: Me, isImaging: xe, generatePdf: _e, generateImage: Ie } = jt({
      elementId: `chord_${T.value}`,
      fileName: a.value.style.chart.title.text || "vue-ui-chord",
      options: a.value.userOptions.print
    }), q = d({
      showTable: a.value.table.show
    });
    function Ae() {
      const t = Ze({
        userConfig: f.config,
        defaultConfig: tt
      });
      return t.theme ? {
        ...Ze({
          userConfig: xt.vue_ui_chord[t.theme] || f.config,
          defaultConfig: t
        }),
        customPalette: Mt[t.theme] || re
      } : t;
    }
    yt(() => f.config, (t) => {
      a.value = Ae(), ue.value = !a.value.userOptions.showOnChartHover, Pe(), ye.value += 1, ke.value += 1, $e.value += 1, I.value = a.value.initialRotation, q.value.showTable = a.value.table.show;
    }, { deep: !0 });
    function Pe() {
      if (_t(f.dataset) ? Qe({
        componentName: "VueUiChord",
        type: "dataset"
      }) : It({
        datasetObject: f.dataset,
        requiredAttributes: ["matrix"]
      }).forEach((t) => {
        L.value = !1, Qe({
          componentName: "VueUiChord",
          type: "datasetAttribute",
          property: t
        });
      }), L.value && Te(), a.value.responsive) {
        const t = G.value.parentNode, o = qt(() => {
          const { width: l, height: n, heightNoTitle: s, heightSource: u, heightTitle: h, heightLegend: C } = Ht({
            chart: G.value,
            title: a.value.style.chart.title.text ? ge.value : null,
            legend: a.value.style.chart.legend.show ? pe.value : null,
            source: be.value,
            noTitle: me.value
          }), M = h + C + u + s;
          l < n ? G.value.style.width = "100%" : (G.value.style.height = "100%", W.value.style.height = `calc(100% - ${M}px)`);
        }, 100), e = new ResizeObserver(o);
        e.observe(t), ne.value = e, o();
      }
      Se.value = setTimeout(() => {
        V.value = !0;
      }, 500);
    }
    function Te() {
      if (!f.dataset || !Object.hasOwn(f.dataset, "matrix") || f.dataset.matrix.length < 2) {
        console.warn(`VueUiChord: dataset.matrix requires a minimum of 2 datapoints, for example:

matrix:[
  [1, 1],
  [1, 1]
]`), L.value = !1;
        return;
      }
      f.dataset.matrix.forEach((t, o) => {
        t.length !== f.dataset.matrix.length && (console.warn(`VueUiChord - Invalid matrix: dataset.matrix at index ${o} has ${t.length} elements instead of the required ${f.dataset.matrix.length}

dataset.matrix[${o}] = [${t.toString()}] has a length of ${t.length} but should have the same length as the matrix itself (${f.dataset.matrix.length})`), L.value = !1);
      });
    }
    const Se = d(null);
    Ve(() => {
      Pe();
    });
    const S = d({
      height: 600,
      width: 600
    }), at = x(() => a.value.userOptions.show && !a.value.style.chart.title.text), ot = x(() => At(a.value.customPalette)), p = x(() => ({
      inner: S.value.width * 0.3 * a.value.style.chart.arcs.innerRadiusRatio,
      outer: S.value.width * 0.34 * a.value.style.chart.arcs.outerRadiusRatio
    })), lt = x(() => a.value.style.chart.arcs.padAngle / 100), y = x(() => L.value ? {
      matrix: f.dataset.matrix ?? [[0]],
      labels: f.dataset.labels ?? [""],
      colors: f.dataset.colors && Array.isArray(f.dataset.colors) && f.dataset.colors.length ? f.dataset.colors.map((t) => Pt(t)) : f.dataset.matrix.map((t, o) => ot.value[o] || re[o] || re[o % re.length])
    } : {
      matrix: [],
      labels: [],
      colors: []
    });
    function st(t, o) {
      const e = t.length, l = p.value.inner, n = new Array(e).fill(0);
      let s = 0;
      for (let c = 0; c < e; c += 1)
        for (let k = 0; k < e; k += 1)
          n[c] += t[c][k], s += t[c][k];
      const u = (2 * Math.PI - o * e) / s, h = [];
      let C = 0;
      for (let c = 0; c < e; c += 1) {
        const k = C, A = k + n[c] * u;
        h.push({
          index: c,
          pattern: `pattern_${T.value}_${c}`,
          startAngle: k,
          endAngle: A,
          name: y.value.labels[c],
          id: ve(),
          color: y.value.colors[c],
          proportion: n[c] / s
        }), C = A + o;
      }
      const M = [];
      for (let c = 0; c < e; c += 1) {
        const k = t[c].map((O, X) => ({ j: X, v: O }));
        k.sort((O, X) => X.v - O.v);
        let A = h[c].startAngle;
        for (const { j: O, v: X } of k) {
          const D = A, Q = D + X * u;
          M.push({
            index: c,
            subIndex: O,
            pattern: `pattern_${T.value}_${c}`,
            startAngle: D,
            endAngle: Q,
            value: X,
            groupName: y.value.labels[c],
            groupId: h[c].id,
            groupColor: y.value.colors[c],
            midAngle: (D + Q) / 2,
            midBaseX: Math.cos((D + Q) / 2 - Math.PI / 2) * l,
            midBaseY: Math.sin((D + Q) / 2 - Math.PI / 2) * l
          }), A = Q;
        }
      }
      const N = [];
      for (const c of M) {
        const k = M.find(
          (A) => A.index === c.subIndex && A.subIndex === c.index
        );
        N.push({ source: c, target: k, id: ve() });
      }
      return { groups: h, chords: N };
    }
    const _ = x(() => {
      const t = st(y.value.matrix, lt.value);
      return Te(), t.chords.sort(
        (o, e) => Math.max(e.source.value, e.target.value) - Math.max(o.source.value, o.target.value)
      ), t;
    }), rt = x(() => {
      const t = p.value.outer + a.value.style.chart.ribbons.labels.offset + 12, e = a.value.style.chart.ribbons.labels.fontSize * 0.6, l = [];
      if (m.value) {
        const s = m.value;
        if (s.source.value) {
          const u = String(s.source.value);
          l.push({
            id: s.id + "-src",
            theta: s.source.midAngle,
            w: u.length * e / t,
            midBaseX: s.source.midBaseX,
            midBaseY: s.source.midBaseY,
            groupColor: s.source.groupColor,
            value: s.source.value
          });
        }
        if (s.target && s.target.value && s.target.value !== s.source.value) {
          const u = String(s.target.value);
          l.push({
            id: s.id + "-tgt",
            theta: s.target.midAngle,
            w: u.length * e / t,
            midBaseX: s.target.midBaseX,
            midBaseY: s.target.midBaseY,
            groupColor: s.target.groupColor,
            value: s.target.value
          });
        }
        return l;
      }
      function n(s) {
        _.value.chords.filter((u) => u.source.groupId === s && u.source.value).forEach((u) => {
          {
            const h = String(u.source.value);
            l.push({
              id: u.id + "-src",
              theta: u.source.midAngle,
              w: h.length * e / t,
              midBaseX: u.source.midBaseX,
              midBaseY: u.source.midBaseY,
              groupColor: u.source.groupColor,
              value: u.source.value
            });
          }
          if (u.target && u.target.value && u.target.value !== u.source.value) {
            const h = String(u.target.value);
            l.push({
              id: u.id + "-tgt",
              theta: u.target.midAngle,
              w: h.length * e / t,
              midBaseX: u.target.midBaseX,
              midBaseY: u.target.midBaseY,
              groupColor: u.target.groupColor,
              value: u.target.value
            });
          }
        });
      }
      return g.value && n(g.value), w.value && n(w.value.id), l;
    }), nt = x(() => {
      const t = rt.value.map((n) => ({ ...n })).sort((n, s) => n.theta - s.theta), o = a.value.style.chart.ribbons.labels.minSeparationDeg * Math.PI / 180;
      let e = !0, l = 0;
      for (; e && l++ < 10; ) {
        e = !1;
        for (let h = 1; h < t.length; h += 1) {
          const C = t[h - 1], M = t[h], N = C.theta + C.w + o;
          M.theta < N && (M.theta = N, e = !0);
        }
        const n = t[0], s = t[t.length - 1], u = s.theta + s.w + o - 2 * Math.PI;
        n.theta < u && (n.theta = u, e = !0);
      }
      return t;
    });
    function Oe(t, o, e, l) {
      const n = t - Math.PI / 2, s = o - Math.PI / 2, u = Math.cos(n) * e, h = Math.sin(n) * e, C = Math.cos(s) * e, M = Math.sin(s) * e, N = Math.cos(s) * l, c = Math.sin(s) * l, k = Math.cos(n) * l, A = Math.sin(n) * l, O = o - t > Math.PI ? 1 : 0;
      return `M${u},${h} A${e},${e} 0 ${O} 1 ${C},${M} L${N},${c} A${l},${l} 0 ${O} 0 ${k},${A} Z`;
    }
    function J(t, o) {
      const e = p.value.inner, l = t.startAngle - Math.PI / 2, n = t.endAngle - Math.PI / 2, s = o.startAngle - Math.PI / 2, u = o.endAngle - Math.PI / 2, h = Math.cos(l) * e, C = Math.sin(l) * e, M = Math.cos(n) * e, N = Math.sin(n) * e, c = Math.cos(s) * e, k = Math.sin(s) * e, A = Math.cos(u) * e, O = Math.sin(u) * e, X = t.endAngle - t.startAngle > Math.PI ? 1 : 0, D = o.endAngle - o.startAngle > Math.PI ? 1 : 0;
      return `M${h},${C}A${e},${e} 0 ${X} 1 ${M},${N}Q0,0 ${c},${k}A${e},${e} 0 ${D} 1 ${A},${O}Q0,0 ${h},${C}Z`;
    }
    const Be = x(() => I.value * Math.PI / 180);
    function ut(t) {
      return (t.startAngle + t.endAngle) / 2;
    }
    function it(t) {
      return ((ut(t) + Be.value) % (2 * Math.PI) + 2 * Math.PI) % (2 * Math.PI);
    }
    function ct(t) {
      let o = t + Be.value;
      return o = (o % (2 * Math.PI) + 2 * Math.PI) % (2 * Math.PI), o > Math.PI ? "end" : "start";
    }
    function dt(t) {
      const o = t - Math.PI / 2, e = Math.cos(o) * (p.value.outer + a.value.style.chart.arcs.labels.offset + 24), l = Math.sin(o) * (p.value.outer + a.value.style.chart.arcs.labels.offset + 24);
      return `translate(${e},${l})`;
    }
    function vt(t, o, e) {
      const l = t - Math.PI / 2, n = o - Math.PI / 2, s = Math.cos(l) * e, u = Math.sin(l) * e, h = Math.cos(n) * e, C = Math.sin(n) * e, M = o - t > Math.PI ? 1 : 0;
      return `M${s},${u} A${e},${e} 0 ${M} 1 ${h},${C}`;
    }
    const I = d(a.value.initialRotation), K = d(!1);
    let Le = 0, Ne = 0;
    function Ee(t) {
      const o = W.value.getBoundingClientRect(), e = o.left + o.width / 2, l = o.top + o.height / 2, n = t.clientX ?? t.touches[0].clientX, s = t.clientY ?? t.touches[0].clientY;
      return Math.atan2(s - l, n - e);
    }
    function ze(t) {
      !a.value.enableRotation || H.value || (t.preventDefault(), K.value = !0, Le = I.value, Ne = Ee(t));
    }
    function ee(t) {
      if (!K.value) return;
      const o = Ee(t);
      I.value = Le + (o - Ne) * 180 / Math.PI;
    }
    function te() {
      K.value = !1;
    }
    function Fe(t) {
      return Lt(
        a.value.style.chart.ribbons.labels.formatter,
        t,
        he({
          p: a.value.style.chart.ribbons.labels.prefix,
          v: t,
          s: a.value.style.chart.ribbons.labels.suffix,
          r: a.value.style.chart.ribbons.labels.rounding
        })
      );
    }
    Ve(() => {
      window.addEventListener("mousemove", ee), window.addEventListener("mouseup", te), window.addEventListener("touchmove", ee, { passive: !1 }), window.addEventListener("touchend", te);
    }), We(() => {
      window.removeEventListener("mousemove", ee), window.removeEventListener("mouseup", te), window.removeEventListener("touchmove", ee), window.removeEventListener("touchend", te), clearTimeout(Se.value), ne.value && ne.value.disconnect();
    });
    const ie = d(!1);
    function ht(t) {
      ie.value = t, fe.value += 1;
    }
    function ft(t) {
      g.value || (w.value = t);
    }
    function gt(t) {
      g.value || (m.value = t);
    }
    function Xe(t) {
      var l;
      return !g.value && !w.value && !m.value ? 0.8 : (g.value ? g.value === t.source.groupId : w.value ? w.value.id === t.source.groupId : ((l = m.value) == null ? void 0 : l.id) === t.id) ? 1 : 0.1;
    }
    function Re(t) {
      var l, n;
      return !g.value && !w.value && !m.value || (g.value ? g.value === t.id : w.value ? w.value.id === t.id : [(l = m.value) == null ? void 0 : l.source.groupId, (n = m.value) == null ? void 0 : n.target.groupId].includes(t.id)) ? 1 : 0.3;
    }
    const H = d(!1);
    function ce() {
      H.value = !H.value;
    }
    function je() {
      q.value.showTable = !q.value.showTable;
    }
    function pt() {
      return _.value;
    }
    const j = d(null);
    function De() {
      const t = a.value.initialRotation;
      j.value !== null && cancelAnimationFrame(j.value);
      const o = () => {
        I.value += (t - I.value) * 0.05, Math.abs(I.value - t) < 0.1 ? (I.value = t, j.value = null) : j.value = requestAnimationFrame(o);
      };
      j.value = requestAnimationFrame(o);
    }
    We(() => {
      j.value !== null && cancelAnimationFrame(j.value);
    });
    function Ue(t) {
      t === g.value ? (g.value = null, Z("selectLegend", null)) : (g.value = t, Z("selectLegend", _.value.groups.find((o) => o.id === t)));
    }
    const Ye = x(() => _.value.groups.map((t, o) => ({
      name: t.name,
      color: t.color,
      shape: "circle",
      patternIndex: o,
      pattern: `pattern_${T.value}_${o}`,
      id: t.id,
      select: () => Ue(t.id),
      opacity: g.value ? g.value === t.id ? 1 : 0.3 : 1
    }))), bt = x(() => ({
      cy: "chord-div-legend",
      backgroundColor: a.value.style.chart.legend.backgroundColor,
      color: a.value.style.chart.legend.color,
      fontSize: a.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: a.value.style.chart.legend.bold ? "bold" : ""
    })), ae = x(() => {
      const t = _.value.groups.map((e, l) => ({
        name: e.name || l,
        color: e.color
      })), o = y.value.matrix;
      return { head: t, body: o };
    }), oe = x(() => {
      const t = [{ name: "", color: null }, ...ae.value.head], o = ae.value.body.map((n, s) => [
        ae.value.head[s],
        ...ae.value.body[s]
      ]), e = {
        th: {
          backgroundColor: a.value.table.th.backgroundColor,
          color: a.value.table.th.color,
          outline: a.value.table.th.outline
        },
        td: {
          backgroundColor: a.value.table.td.backgroundColor,
          color: a.value.table.td.color,
          outline: a.value.table.td.outline
        },
        breakpoint: a.value.table.responsiveBreakpoint
      };
      return {
        colNames: t,
        head: t,
        body: o,
        config: e
      };
    });
    function Ge() {
      wt(() => {
        const t = y.value.matrix.map((l, n) => [
          [y.value.labels[n] || n],
          l
        ]), o = [
          [a.value.style.chart.title.text],
          [a.value.style.chart.title.subtitle.text],
          [
            [""],
            ...y.value.labels.map((l, n) => [l || n])
          ]
        ].concat(t), e = Ot(o);
        Bt({ csvContent: e, title: a.value.style.chart.title.text || "vue-ui-chord" });
      });
    }
    return Ke({
      getData: pt,
      generateCsv: Ge,
      generateImage: Ie,
      generatePdf: _e,
      toggleAnnotator: ce,
      toggleTable: je
    }), (t, o) => (r(), i("div", {
      ref_key: "chordChart",
      ref: G,
      class: z({
        "vue-ui-chord": !0,
        "vue-data-ui-wrapper-fullscreen": ie.value,
        "vue-data-ui-responsive": a.value.responsive
      }),
      style: E(`font-family:${a.value.style.fontFamily};width:100%; text-align:center;background:${a.value.style.chart.backgroundColor}`),
      id: `chord_${T.value}`,
      onMouseenter: o[4] || (o[4] = () => b(we)(!0)),
      onMouseleave: o[5] || (o[5] = () => b(we)(!1))
    }, [
      a.value.userOptions.buttons.annotator && b(W) ? (r(), U(Xt, {
        key: 0,
        color: a.value.style.chart.color,
        backgroundColor: a.value.style.chart.backgroundColor,
        active: H.value,
        svgRef: b(W),
        onClose: ce
      }, null, 8, ["color", "backgroundColor", "active", "svgRef"])) : v("", !0),
      $(t.$slots, "userConfig", {}, void 0, !0),
      at.value ? (r(), i("div", {
        key: 1,
        ref_key: "noTitle",
        ref: me,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : v("", !0),
      a.value.style.chart.title.text ? (r(), i("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: ge,
        style: "width:100%;background:transparent;padding-bottom:24px"
      }, [
        (r(), U(zt, {
          key: `title_${ye.value}`,
          config: {
            title: {
              cy: "chord-div-title",
              ...a.value.style.chart.title
            },
            subtitle: {
              cy: "chord-div-subtitle",
              ...a.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : v("", !0),
      a.value.userOptions.show && L.value && (b(Ce) || b(ue)) ? (r(), U(Dt, {
        ref: "details",
        key: `user_option_${fe.value}`,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        isPrinting: b(Me),
        isImaging: b(xe),
        uid: T.value,
        hasTooltip: !1,
        hasPdf: a.value.userOptions.buttons.pdf,
        hasImg: a.value.userOptions.buttons.img,
        hasXls: a.value.userOptions.buttons.csv,
        hasTable: a.value.userOptions.buttons.table,
        hasLabel: !1,
        hasFullscreen: a.value.userOptions.buttons.fullscreen,
        isFullscreen: ie.value,
        chartElement: G.value,
        position: a.value.userOptions.position,
        titles: { ...a.value.userOptions.buttonTitles },
        hasAnnotator: a.value.userOptions.buttons.annotator,
        isAnnotation: H.value,
        onToggleFullscreen: ht,
        onGeneratePdf: b(_e),
        onGenerateCsv: Ge,
        onGenerateImage: b(Ie),
        onToggleTable: je,
        onToggleAnnotator: ce,
        style: E({
          visibility: b(Ce) ? b(ue) ? "visible" : "hidden" : "visible"
        })
      }, qe({ _: 2 }, [
        t.$slots.menuIcon ? {
          name: "menuIcon",
          fn: P(({ isOpen: e, color: l }) => [
            $(t.$slots, "menuIcon", le(se({ isOpen: e, color: l })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: P(() => [
            $(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: P(() => [
            $(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: P(() => [
            $(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: P(() => [
            $(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: P(({ toggleFullscreen: e, isFullscreen: l }) => [
            $(t.$slots, "optionFullscreen", le(se({ toggleFullscreen: e, isFullscreen: l })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: P(({ toggleAnnotator: e, isAnnotator: l }) => [
            $(t.$slots, "optionAnnotator", le(se({ toggleAnnotator: e, isAnnotator: l })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "chartElement", "position", "titles", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : v("", !0),
      L.value ? (r(), i("svg", {
        key: 4,
        xmlns: b(Tt),
        ref_key: "svgRef",
        ref: W,
        viewBox: `0 0 ${S.value.width} ${S.value.height}`,
        preserveAspectRatio: "xMidYMid meet",
        style: {
          overflow: "visible"
        },
        class: z({ "vue-ui-chord-rotating": K.value, "vue-ui-chord-idle": !t.rotating }),
        onMousedown: He(ze, ["prevent"]),
        onTouchstart: He(ze, ["prevent"])
      }, [
        de(Ft),
        t.$slots["chart-background"] ? (r(), i("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: S.value.width <= 0 ? 10 : S.value.width,
          height: S.value.height <= 0 ? 10 : S.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          $(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Kt)) : v("", !0),
        a.value.style.chart.arcs.labels.curved ? (r(), i("defs", ea, [
          (r(!0), i(F, null, Y(_.value.groups, (e, l) => (r(), i("path", {
            key: `labelPath-${l}`,
            id: `labelPath-${l}_${T.value}`,
            d: vt(
              e.startAngle,
              e.endAngle,
              (p.value.inner + p.value.outer) / 2 + a.value.style.chart.arcs.labels.offset
            ),
            fill: "none"
          }, null, 8, ta))), 128))
        ])) : v("", !0),
        t.$slots.pattern ? (r(), i("g", aa, [
          (r(!0), i(F, null, Y(_.value.groups, (e, l) => (r(), i("defs", null, [
            $(t.$slots, "pattern", kt({ ref_for: !0 }, { seriesIndex: e.index, patternId: `pattern_${T.value}_${l}` }), void 0, !0)
          ]))), 256))
        ])) : v("", !0),
        B("g", {
          transform: `translate(${S.value.width / 2}, ${S.value.height / 2}) rotate(${I.value})`
        }, [
          (r(!0), i(F, null, Y(_.value.groups, (e, l) => (r(), i("g", null, [
            (r(), i("path", {
              class: z({ "vue-ui-chord-arc": !0, "vue-ui-chord-arc-animated": a.value.useCssAnimation && !V.value }),
              key: `arc-${l}`,
              d: Oe(
                e.startAngle,
                e.endAngle,
                p.value.outer,
                p.value.inner
              ),
              fill: y.value.colors[l],
              stroke: a.value.style.chart.arcs.stroke,
              "stroke-width": a.value.style.chart.arcs.strokeWidth,
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              style: E({
                opacity: Re(e)
              }),
              onMouseenter: () => ft(e),
              onMouseleave: o[0] || (o[0] = (n) => w.value = null),
              onClick: (n) => Z("selectGroup", e)
            }, null, 46, la)),
            t.$slots.pattern ? (r(), i("path", {
              class: z({ "vue-ui-chord-arc": !0, "vue-ui-chord-arc-animated": a.value.useCssAnimation && !V.value }),
              key: `arc-${l}`,
              d: Oe(
                e.startAngle,
                e.endAngle,
                p.value.outer,
                p.value.inner
              ),
              fill: `url(#${e.pattern})`,
              stroke: a.value.style.chart.arcs.stroke,
              "stroke-width": a.value.style.chart.arcs.strokeWidth,
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              style: E({
                opacity: Re(e),
                pointerEvents: "none"
              })
            }, null, 14, sa)) : v("", !0)
          ]))), 256)),
          B("g", null, [
            (r(!0), i(F, null, Y(w.value ? _.value.chords.filter((e) => e.source.groupId === w.value.id) : g.value ? _.value.chords.filter((e) => e.source.groupId === g.value) : _.value.chords, (e) => (r(), i(F, {
              key: `ribbon-${e.id}`
            }, [
              e.source.value ? (r(), i("path", {
                key: 0,
                class: z({ "vue-ui-chord-ribbon": !0, "vue-ui-chord-ribbon-animated": a.value.useCssAnimation && !V.value }),
                d: J(e.source, e.target),
                fill: a.value.style.chart.backgroundColor,
                style: E({ opacity: a.value.style.chart.ribbons.underlayerOpacity })
              }, null, 14, ra)) : v("", !0),
              e.source.value ? (r(), i("path", {
                key: 1,
                class: z({ "vue-ui-chord-ribbon": !0, "vue-ui-chord-ribbon-animated": a.value.useCssAnimation && !V.value }),
                d: J(e.source, e.target),
                fill: y.value.colors[e.source.index],
                stroke: a.value.style.chart.ribbons.stroke,
                "stroke-width": a.value.style.chart.ribbons.strokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                style: E({ opacity: Xe(e) }),
                onMouseenter: () => gt({
                  ...e,
                  path: J(e.source, e.target),
                  color: y.value.colors[e.source.index]
                }),
                onClick: (l) => Z("selectRibbon", {
                  ...e,
                  color: y.value.colors[e.source.index]
                }),
                onMouseleave: o[1] || (o[1] = (l) => m.value = null)
              }, null, 46, na)) : v("", !0),
              e.source.value && t.$slots.pattern ? (r(), i("path", {
                key: 2,
                class: z({ "vue-ui-chord-ribbon": !0, "vue-ui-chord-ribbon-animated": a.value.useCssAnimation && !V.value }),
                d: J(e.source, e.target),
                fill: `url(#pattern_${T.value}_${e.source.index})`,
                stroke: a.value.style.chart.ribbons.stroke,
                "stroke-width": a.value.style.chart.ribbons.strokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                style: E({
                  opacity: Xe(e),
                  pointerEvents: "none"
                })
              }, null, 14, ua)) : v("", !0)
            ], 64))), 128)),
            m.value ? (r(), i("path", {
              key: 0,
              d: m.value.path,
              fill: m.value.color,
              stroke: a.value.style.chart.ribbons.stroke,
              "stroke-width": a.value.style.chart.ribbons.strokeWidth,
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              class: z({ "vue-ui-chord-ribbon": !0 }),
              style: {
                pointerEvents: "none"
              }
            }, null, 8, ia)) : v("", !0),
            m.value && t.$slots.pattern ? (r(), i("path", {
              key: 1,
              d: m.value.path,
              fill: `url(#${m.value.source.pattern})`,
              stroke: a.value.style.chart.ribbons.stroke,
              "stroke-width": a.value.style.chart.ribbons.strokeWidth,
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              class: z({ "vue-ui-chord-ribbon": !0 }),
              style: {
                pointerEvents: "none"
              }
            }, null, 8, ca)) : v("", !0)
          ]),
          (w.value || m.value || g.value) && a.value.style.chart.ribbons.labels.show ? (r(), i("g", da, [
            (r(!0), i(F, null, Y(nt.value, (e) => (r(), i(F, {
              key: e.id
            }, [
              B("line", {
                x1: e.midBaseX,
                y1: e.midBaseY,
                x2: Math.cos(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 12),
                y2: Math.sin(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 12),
                stroke: a.value.style.chart.backgroundColor,
                "stroke-width": a.value.style.chart.ribbons.labels.connector.strokeWidth * 3,
                "pointer-events": "none"
              }, null, 8, va),
              B("line", {
                x1: e.midBaseX,
                y1: e.midBaseY,
                x2: Math.cos(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 12),
                y2: Math.sin(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 12),
                stroke: a.value.style.chart.ribbons.labels.connector.stroke,
                "stroke-width": a.value.style.chart.ribbons.labels.connector.strokeWidth,
                "pointer-events": "none"
              }, null, 8, ha),
              a.value.style.chart.ribbons.labels.marker.show ? (r(), i("circle", {
                key: 0,
                cx: Math.cos(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 12),
                cy: Math.sin(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 12),
                r: a.value.style.chart.ribbons.labels.marker.radius,
                stroke: a.value.style.chart.ribbons.labels.marker.stroke,
                "stroke-width": a.value.style.chart.ribbons.labels.marker.strokeWidth,
                fill: e.groupColor,
                "pointer-events": "none"
              }, null, 8, fa)) : v("", !0),
              B("text", {
                transform: `
                            translate(
                                ${Math.cos(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 24)},
                                ${Math.sin(e.theta - Math.PI / 2) * (p.value.outer + a.value.style.chart.ribbons.labels.offset + 24)}
                            ) rotate(${-I.value})
                            `,
                fill: a.value.style.chart.ribbons.labels.useSerieColor ? e.groupColor : a.value.style.chart.ribbons.labels.color,
                "text-anchor": ct(e.theta),
                "font-size": a.value.style.chart.ribbons.labels.fontSize,
                "font-weight": a.value.style.chart.ribbons.labels.bold ? "bold" : "normal",
                dy: ".35em",
                "pointer-events": "none"
              }, R(Fe(e.value)), 9, ga)
            ], 64))), 128))
          ])) : v("", !0),
          a.value.style.chart.arcs.labels.show ? (r(), i("g", pa, [
            a.value.style.chart.arcs.labels.curved ? (r(!0), i(F, { key: 0 }, Y(_.value.groups, (e, l) => (r(), i("text", {
              key: `curved-label-${l}`,
              "font-size": a.value.style.chart.arcs.labels.fontSize,
              "font-weight": a.value.style.chart.arcs.labels.bold ? "bold" : "normal",
              fill: a.value.style.chart.arcs.labels.adaptColorToBackground ? b(St)(y.value.colors[l]) : a.value.style.chart.arcs.labels.color
            }, [
              B("textPath", {
                href: `#labelPath-${l}_${T.value}`,
                startOffset: "50%",
                "text-anchor": "middle"
              }, R(y.value.labels[l]) + R(a.value.style.chart.arcs.labels.showPercentage ? b(he)({
                p: " (",
                v: isNaN(e.proportion) ? 0 : e.proportion * 100,
                s: "%)",
                r: a.value.style.chart.arcs.labels.roundingPercentage
              }) : ""), 9, ma)
            ], 8, ba))), 128)) : !w.value && !m.value && !g.value ? (r(!0), i(F, { key: 1 }, Y(_.value.groups, (e, l) => (r(), i("text", {
              key: `label-${l}`,
              transform: `
                                ${dt((e.startAngle + e.endAngle) / 2)}
                                rotate(${-I.value})
                            `,
              dy: ".35em",
              "text-anchor": it(e) > Math.PI ? "end" : "start",
              "font-size": a.value.style.chart.arcs.labels.fontSize,
              "font-weight": a.value.style.chart.arcs.labels.bold ? "bold" : "normal",
              fill: a.value.style.chart.arcs.labels.color
            }, R(y.value.labels[l]) + R(a.value.style.chart.arcs.labels.showPercentage ? b(he)({
              p: " (",
              v: isNaN(e.proportion) ? 0 : e.proportion * 100,
              s: "%)",
              r: a.value.style.chart.arcs.labels.roundingPercentage
            }) : ""), 9, ya))), 128)) : v("", !0)
          ])) : v("", !0)
        ], 8, oa),
        $(t.$slots, "svg", { svg: { height: 600, width: 600 } }, void 0, !0)
      ], 42, Jt)) : v("", !0),
      t.$slots.watermark ? (r(), i("div", ka, [
        $(t.$slots, "watermark", le(se({ isPrinting: b(Me) || b(xe) })), void 0, !0)
      ])) : v("", !0),
      L.value ? v("", !0) : (r(), U(Wt, {
        key: 6,
        config: {
          type: "chord",
          style: {
            backgroundColor: a.value.style.chart.backgroundColor,
            chord: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      B("div", {
        ref_key: "chartLegend",
        ref: pe
      }, [
        a.value.style.chart.legend.show ? (r(), U(Ut, {
          key: `legend_${$e.value}`,
          legendSet: Ye.value,
          config: bt.value,
          onClickMarker: o[2] || (o[2] = ({ legend: e }) => Ue(e.id))
        }, qe({
          item: P(({ legend: e, index: l }) => [
            B("div", {
              style: E({
                opacity: g.value ? g.value === e.id ? 1 : 0.3 : 1
              }),
              onClick: (n) => e.select()
            }, R(e.name), 13, $a)
          ]),
          _: 2
        }, [
          t.$slots.pattern ? {
            name: "legend-pattern",
            fn: P(({ legend: e, index: l }) => [
              de(Yt, {
                shape: e.shape,
                radius: 30,
                stroke: "none",
                plot: { x: 30, y: 30 },
                fill: `url(#pattern_${T.value}_${l})`
              }, null, 8, ["shape", "fill"])
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["legendSet", "config"])) : v("", !0),
        $(t.$slots, "legend", { legend: Ye.value }, void 0, !0)
      ], 512),
      t.$slots.source ? (r(), i("div", {
        key: 7,
        ref_key: "source",
        ref: be,
        dir: "auto"
      }, [
        $(t.$slots, "source", {}, void 0, !0)
      ], 512)) : v("", !0),
      I.value !== a.value.initialRotation ? (r(), i("div", wa, [
        $(t.$slots, "reset-action", { reset: De }, () => [
          B("button", {
            "data-cy-reset": "",
            tabindex: "0",
            role: "button",
            class: "vue-data-ui-refresh-button",
            style: E({
              background: a.value.style.chart.backgroundColor
            }),
            onClick: De
          }, [
            de(Rt, {
              name: "refresh",
              stroke: a.value.style.chart.color
            }, null, 8, ["stroke"])
          ], 4)
        ], !0)
      ])) : v("", !0),
      L.value ? (r(), U(Vt, {
        key: 9,
        hideDetails: "",
        config: {
          open: q.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          },
          head: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          }
        }
      }, {
        content: P(() => [
          (r(), U(Gt, {
            key: `table_${ke.value}`,
            colNames: oe.value.colNames,
            head: oe.value.head,
            body: oe.value.body,
            config: oe.value.config,
            title: `${a.value.style.chart.title.text}${a.value.style.chart.title.subtitle.text ? ` : ${a.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[3] || (o[3] = (e) => q.value.showTable = !1)
          }, {
            th: P(({ th: e }) => [
              $t(R(e.name), 1)
            ]),
            td: P(({ td: e }) => [
              B("div", Ca, R(e.name ? e.name : Fe(e)), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 46, Zt));
  }
}, Da = /* @__PURE__ */ Qt(Ma, [["__scopeId", "data-v-0406fd61"]]);
export {
  Da as default
};
